diff --git a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.hxx b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.hxx
index 5a529f3057..610868aa5a 100644
--- a/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkMorphologicalWatershedImageFilter.hxx
@@ -28,48 +28,41 @@
 namespace itk
 {
 
-template< typename TInputImage, typename TOutputImage >
-MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
-::MorphologicalWatershedImageFilter():
-  m_FullyConnected( false ),
-  m_MarkWatershedLine( true ),
-  m_Level( NumericTraits< InputImagePixelType >::ZeroValue() )
-{
-}
+template <typename TInputImage, typename TOutputImage>
+MorphologicalWatershedImageFilter<TInputImage, TOutputImage>::MorphologicalWatershedImageFilter()
+  : m_Level(NumericTraits<InputImagePixelType>::ZeroValue())
+{}
 
 
-template< typename TInputImage, typename TOutputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
-::GenerateInputRequestedRegion()
+MorphologicalWatershedImageFilter<TInputImage, TOutputImage>::GenerateInputRequestedRegion()
 {
   // call the superclass' implementation of this method
   Superclass::GenerateInputRequestedRegion();
 
   // We need all the input.
-  InputImageType * input = const_cast< InputImageType * >( this->GetInput() );
-  if ( !input )
-    {
+  auto * input = const_cast<InputImageType *>(this->GetInput());
+  if (!input)
+  {
     return;
-    }
-  input->SetRequestedRegion( input->GetLargestPossibleRegion() );
+  }
+  input->SetRequestedRegion(input->GetLargestPossibleRegion());
 }
 
 
-template< typename TInputImage, typename TOutputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
-::EnlargeOutputRequestedRegion(DataObject *)
+MorphologicalWatershedImageFilter<TInputImage, TOutputImage>::EnlargeOutputRequestedRegion(DataObject *)
 {
   OutputImageType * output = this->GetOutput();
-  output->SetRequestedRegion( output->GetLargestPossibleRegion() );
+  output->SetRequestedRegion(output->GetLargestPossibleRegion());
 }
 
 
-template< typename TInputImage, typename TOutputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
-::GenerateData()
+MorphologicalWatershedImageFilter<TInputImage, TOutputImage>::GenerateData()
 {
   // Create a process accumulator for tracking the progress of this minipipeline
   ProgressAccumulator::Pointer progress = ProgressAccumulator::New();
@@ -82,83 +75,78 @@ MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
   const InputImageType * input = this->GetInput();
 
   // h-minima filter to remove the smallest minima
-  typedef HMinimaImageFilter< TInputImage, TInputImage > HMinimaType;
+  using HMinimaType = HMinimaImageFilter<TInputImage, TInputImage>;
   typename HMinimaType::Pointer hmin;
 
   // Delegate to a R-Min filter to find the regional minima
-  typedef RegionalMinimaImageFilter< TInputImage, TOutputImage > RMinType;
+  using RMinType = RegionalMinimaImageFilter<TInputImage, TOutputImage>;
   typename RMinType::Pointer rmin = RMinType::New();
-  rmin->SetInput( input );
+  rmin->SetInput(input);
   rmin->SetFullyConnected(m_FullyConnected);
-  rmin->SetBackgroundValue(NumericTraits< OutputImagePixelType >::ZeroValue());
-  rmin->SetForegroundValue( NumericTraits< OutputImagePixelType >::max() );
+  rmin->SetBackgroundValue(NumericTraits<OutputImagePixelType>::ZeroValue());
+  rmin->SetForegroundValue(NumericTraits<OutputImagePixelType>::max());
 
   // label the components
-  typedef ConnectedComponentImageFilter< TOutputImage, TOutputImage >
-  ConnectedCompType;
+  using ConnectedCompType = ConnectedComponentImageFilter<TOutputImage, TOutputImage>;
   typename ConnectedCompType::Pointer label = ConnectedCompType::New();
   label->SetFullyConnected(m_FullyConnected);
-  label->SetInput( rmin->GetOutput() );
+  label->SetInput(rmin->GetOutput());
 
   // the watershed
-  typedef
-  MorphologicalWatershedFromMarkersImageFilter< TInputImage, TOutputImage >
-  WatershedType;
-  typename WatershedType::Pointer wshed = WatershedType::New();
-  wshed->SetInput( input );
-  wshed->SetMarkerImage( label->GetOutput() );
+  typedef MorphologicalWatershedFromMarkersImageFilter<TInputImage, TOutputImage> WatershedType;
+  typename WatershedType::Pointer                                                 wshed = WatershedType::New();
+  wshed->SetInput(input);
+  wshed->SetMarkerImage(label->GetOutput());
   wshed->SetFullyConnected(m_FullyConnected);
   wshed->SetMarkWatershedLine(m_MarkWatershedLine);
 
-  if ( m_Level != NumericTraits< InputImagePixelType >::ZeroValue() )
-    {
+  if (m_Level != NumericTraits<InputImagePixelType>::ZeroValue())
+  {
     // insert a h-minima filter to remove the smallest minima
     //
     hmin = HMinimaType::New();
-    hmin->SetInput( input );
+    hmin->SetInput(input);
     hmin->SetHeight(m_Level);
     hmin->SetFullyConnected(m_FullyConnected);
     // replace the input of the r-min filter
-    rmin->SetInput( hmin->GetOutput() );
+    rmin->SetInput(hmin->GetOutput());
 
     progress->RegisterInternalFilter(hmin, 0.4f);
     progress->RegisterInternalFilter(rmin, 0.1f);
     progress->RegisterInternalFilter(label, .2f);
     progress->RegisterInternalFilter(wshed, .3f);
-    }
+  }
   else
-    {
+  {
     // don't insert the h-minima to save some ressources
     progress->RegisterInternalFilter(rmin, 0.167f);
     progress->RegisterInternalFilter(label, .333f);
     progress->RegisterInternalFilter(wshed, .5f);
-    }
+  }
 
   // run the algorithm
   // graft our output to the watershed filter to force the proper regions
   // to be generated
-  wshed->GraftOutput( this->GetOutput() );
+  wshed->GraftOutput(this->GetOutput());
 
   wshed->Update();
 
   // graft the output of the watershed filter back onto this filter's
   // output. this is needed to get the appropriate regions passed
   // back.
-  this->GraftOutput( wshed->GetOutput() );
+  this->GraftOutput(wshed->GetOutput());
 }
 
 
-template< typename TInputImage, typename TOutputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-MorphologicalWatershedImageFilter< TInputImage, TOutputImage >
-::PrintSelf(std::ostream & os, Indent indent) const
+MorphologicalWatershedImageFilter<TInputImage, TOutputImage>::PrintSelf(std::ostream & os, Indent indent) const
 {
   Superclass::PrintSelf(os, indent);
 
-  os << indent << "FullyConnected: "  << m_FullyConnected << std::endl;
-  os << indent << "MarkWatershedLine: "  << m_MarkWatershedLine << std::endl;
-  os << indent << "Level: "
-     << static_cast< typename NumericTraits< InputImagePixelType >::PrintType >( m_Level )
+  os << indent << "FullyConnected: " << m_FullyConnected << std::endl;
+  os << indent << "MarkWatershedLine: " << m_MarkWatershedLine << std::endl;
+  os << indent << "Level: " << static_cast<typename NumericTraits<InputImagePixelType>::PrintType>(m_Level)
      << std::endl;
 }
 
diff --git a/Modules/Segmentation/Watersheds/include/itkOneWayEquivalencyTable.h b/Modules/Segmentation/Watersheds/include/itkOneWayEquivalencyTable.h
index bcf8db7f83..1d97fc5ce9 100644
--- a/Modules/Segmentation/Watersheds/include/itkOneWayEquivalencyTable.h
+++ b/Modules/Segmentation/Watersheds/include/itkOneWayEquivalencyTable.h
@@ -20,7 +20,7 @@
 
 
 #include "itkProcessObject.h"
-#include "itksys/hash_map.hxx"
+#include <unordered_map>
 #include "ITKWatershedsExport.h"
 
 namespace itk
@@ -43,93 +43,127 @@ namespace itk
  * \sa EquivalencyTable
  * \ingroup ITKWatersheds
  */
-class ITKWatersheds_EXPORT OneWayEquivalencyTable:public DataObject
+class ITKWatersheds_EXPORT OneWayEquivalencyTable : public DataObject
 {
 public:
-  /**  Standard typedefs and smart pointer declarations.   */
-  typedef OneWayEquivalencyTable     Self;
-  typedef DataObject                 Superclass;
-  typedef SmartPointer< Self >       Pointer;
-  typedef SmartPointer< const Self > ConstPointer;
+  ITK_DISALLOW_COPY_AND_ASSIGN(OneWayEquivalencyTable);
+
+  /**  Standard type alias and smart pointer declarations.   */
+  using Self = OneWayEquivalencyTable;
+  using Superclass = DataObject;
+  using Pointer = SmartPointer<Self>;
+  using ConstPointer = SmartPointer<const Self>;
   itkNewMacro(Self);
   itkTypeMacro(OneWayEquivalencyTable, DataObject);
 
   /** Define the container type for this table */
-  typedef itksys::hash_map< unsigned long, unsigned long,
-                            itksys::hash< unsigned long > > HashTableType;
+  using HashTableType = std::unordered_map<unsigned long, unsigned long>;
 
-  typedef HashTableType::iterator       Iterator;
-  typedef HashTableType::const_iterator ConstIterator;
-  typedef HashTableType::value_type     ValueType;
+  using Iterator = HashTableType::iterator;
+  using ConstIterator = HashTableType::const_iterator;
+  using ValueType = HashTableType::value_type;
 
   /** "Flattens" the equivalency table by eliminating all redundant
    * and recursive equivalencies.  I.e. the set { 2=1; 3=2; 4=3 } is
    * converted to {4=1; 3=1; 2=1}.  */
-  void Flatten();
+  void
+  Flatten();
 
   /** Insert an equivalency into the table.  A return value of TRUE
-  * indicates that the equivalency did not previously exist in the
-  * table and was successfully added.  A FALSE return value indicates
-  * that the equivalency was not added to the table because a conflict
-  * with an existing entry occurred (most likely, the equivalency was
-  * already recorded directly or indirectly).
-  */
-  bool Add(unsigned long a, unsigned long b);
+   * indicates that the equivalency did not previously exist in the
+   * table and was successfully added.  A FALSE return value indicates
+   * that the equivalency was not added to the table because a conflict
+   * with an existing entry occurred (most likely, the equivalency was
+   * already recorded directly or indirectly).
+   */
+  bool
+  Add(unsigned long a, unsigned long b);
 
   /** Lookup an equivalency in the table.  If no entry is found in the
    * table, the method returns its the value of the argument.  Does
    * not recursively descent through equivalencies.  */
-  unsigned long Lookup(const unsigned long a) const
+  unsigned long
+  Lookup(const unsigned long a) const
   {
     ConstIterator result = m_HashMap.find(a);
 
-    if ( result == m_HashMap.end() ) { return a; }
-    else { return ( *result ).second; }
+    if (result == m_HashMap.end())
+    {
+      return a;
+    }
+    else
+    {
+      return (*result).second;
+    }
   }
 
   /** Lookup an equivalency in the table by recursing through all
    * successive equivalencies.  For example, if the follow entries
    * exist in the table {8=7, 7=6, 6=5}, then RecursiveLookup(8)
    * returns 5.  */
-  unsigned long RecursiveLookup(const unsigned long a) const;
+  unsigned long
+  RecursiveLookup(const unsigned long a) const;
 
   /** Returns TRUE if the label is found in the table and FALSE is the
    * label is not found in the table.  */
-  bool IsEntry(const unsigned long a) const
+  bool
+  IsEntry(const unsigned long a) const
   {
-    if ( m_HashMap.find(a) == m_HashMap.end() ) { return false; }
-    else { return true; }
+    if (m_HashMap.find(a) == m_HashMap.end())
+    {
+      return false;
+    }
+    else
+    {
+      return true;
+    }
   }
 
   /**  Erases the entry with key a.   */
-  void Erase(const unsigned long a)
-  {  m_HashMap.erase(a); }
+  void
+  Erase(const unsigned long a)
+  {
+    m_HashMap.erase(a);
+  }
 
   /** Erases all the entries in the table.   */
-  void Clear()
-  {      m_HashMap.clear();    }
+  void
+  Clear()
+  {
+    m_HashMap.clear();
+  }
 
   /** Returns TRUE if the table is empty, FALSE if it is not empty.   */
-  bool Empty() const
-  {      return m_HashMap.empty();    }
+  bool
+  Empty() const
+  {
+    return m_HashMap.empty();
+  }
 
   /** Returns an iterator pointing to the first element of the (unordered)
       table.    */
-  Iterator Begin() { return m_HashMap.begin(); }
+  Iterator
+  Begin()
+  {
+    return m_HashMap.begin();
+  }
 
   /** Returns and iterator pointing to one position past the last
    * element of the (unordered) table.  */
-  Iterator End()   { return m_HashMap.end();   }
+  Iterator
+  End()
+  {
+    return m_HashMap.end();
+  }
 
   /** Convenience method for debugging.   */
   //  void PrintHashTable();
 
 protected:
-  OneWayEquivalencyTable()  {}
-  ~OneWayEquivalencyTable() ITK_OVERRIDE {}
-  ITK_DISALLOW_COPY_AND_ASSIGN(OneWayEquivalencyTable);
-
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
+  OneWayEquivalencyTable() = default;
+  ~OneWayEquivalencyTable() override = default;
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
 
   HashTableType m_HashMap;
 };
diff --git a/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.h b/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.h
index 026db2c32f..2c7879f856 100644
--- a/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.h
+++ b/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.h
@@ -35,50 +35,52 @@ namespace itk
  * \ingroup ITKWatersheds
  */
 
-template< typename TInputImage >
-class ITK_TEMPLATE_EXPORT TobogganImageFilter:
-  public ImageToImageFilter<
-    TInputImage,
-    Image< IdentifierType, TInputImage::ImageDimension > >
+template <typename TInputImage, typename TOutputImage = Image<IdentifierType, TInputImage::ImageDimension>>
+class ITK_TEMPLATE_EXPORT TobogganImageFilter : public ImageToImageFilter<TInputImage, TOutputImage>
 {
 public:
-  /** Standard "Self" typedef.   */
-  typedef TobogganImageFilter Self;
+  ITK_DISALLOW_COPY_AND_ASSIGN(TobogganImageFilter);
+
+  /** Standard "Self" type alias.   */
+  using Self = TobogganImageFilter;
 
   /** The type of input image.   */
-  typedef TInputImage InputImageType;
+  using InputImageType = TInputImage;
 
   /** Number of dimensions. */
-  itkStaticConstMacro(NDimensions, unsigned int, TInputImage::ImageDimension);
+  static constexpr unsigned int NDimensions = TInputImage::ImageDimension;
 
   /** The type of output image.   */
-  typedef Image< IdentifierType, itkGetStaticConstMacro(NDimensions) > OutputImageType;
+  using OutputImageType = TOutputImage;
 
   /** Output image pixel type. */
-  typedef typename OutputImageType::PixelType OutputImagePixelType;
+  using OutputImagePixelType = typename OutputImageType::PixelType;
 
   /** Input image pixel type. */
-  typedef typename InputImageType::PixelType InputImagePixelType;
+  using InputImagePixelType = typename InputImageType::PixelType;
 
   /** Dimension of the input and output images. */
-  enum { ImageDimension = InputImageType::ImageDimension };
-
-  /** Other convenient typedefs   */
-  typedef typename InputImageType::RegionType   RegionType;
-  typedef typename InputImageType::SizeType     SizeType;
-  typedef typename InputImageType::IndexType    IndexType;
-  typedef typename InputImageType::Pointer      InputImagePointer;
-  typedef typename InputImageType::ConstPointer InputImageConstPointer;
-  typedef typename OutputImageType::Pointer     OutputImagePointer;
-
-  /** Standard super class typedef support. */
-  typedef ImageToImageFilter< InputImageType, OutputImageType > Superclass;
+  enum
+  {
+    ImageDimension = InputImageType::ImageDimension
+  };
+
+  /** Other convenient type alias   */
+  using RegionType = typename InputImageType::RegionType;
+  using SizeType = typename InputImageType::SizeType;
+  using IndexType = typename InputImageType::IndexType;
+  using InputImagePointer = typename InputImageType::Pointer;
+  using InputImageConstPointer = typename InputImageType::ConstPointer;
+  using OutputImagePointer = typename OutputImageType::Pointer;
+
+  /** Standard super class type alias support */
+  using Superclass = ImageToImageFilter<InputImageType, OutputImageType>;
 
   /** Typedef support for the input image scalar value type. */
-  typedef typename InputImageType::PixelType ScalarType;
+  using ScalarType = typename InputImageType::PixelType;
 
-  /** Smart pointer typedef support  */
-  typedef SmartPointer< Self > Pointer;
+  /** Smart pointer type alias support  */
+  using Pointer = SmartPointer<Self>;
 
   /** Run-time type information (and related methods) */
   itkTypeMacro(TobogganImageFilter, ImageToImageFilter);
@@ -87,37 +89,35 @@ public:
   itkNewMacro(Self);
 
   /** Standard process object method.  This filter is not multithreaded. */
-  void GenerateData() ITK_OVERRIDE;
+  void
+  GenerateData() override;
 
-  void GenerateInputRequestedRegion() ITK_OVERRIDE;
+  void
+  GenerateInputRequestedRegion() override;
 
-  void EnlargeOutputRequestedRegion(DataObject *) ITK_OVERRIDE;
+  void
+  EnlargeOutputRequestedRegion(DataObject *) override;
 
   /** Neighborhood iterator type */
-  typedef ConstNeighborhoodIterator< TInputImage >
-  NeighborhoodIteratorType;
+  using NeighborhoodIteratorType = ConstNeighborhoodIterator<Image<float, 2>>;
 
 #ifdef ITK_USE_CONCEPT_CHECKING
   // Begin concept checking
-  itkConceptMacro( LessThanComparableCheck,
-                   ( Concept::LessThanComparable< InputImagePixelType > ) );
-  itkConceptMacro( OStreamWritableCheck,
-                   ( Concept::OStreamWritable< InputImagePixelType > ) );
+  itkConceptMacro(LessThanComparableCheck, (Concept::LessThanComparable<InputImagePixelType>));
+  itkConceptMacro(OStreamWritableCheck, (Concept::OStreamWritable<InputImagePixelType>));
   // End concept checking
 #endif
 
 protected:
-  TobogganImageFilter();
-  ~TobogganImageFilter() ITK_OVERRIDE {}
-  void PrintSelf(std::ostream & os, Indent indent) const ITK_OVERRIDE;
-
-private:
-  ITK_DISALLOW_COPY_AND_ASSIGN(TobogganImageFilter);
-};                                   // end of class
+  TobogganImageFilter() = default;
+  ~TobogganImageFilter() override = default;
+  void
+  PrintSelf(std::ostream & os, Indent indent) const override;
+}; // end of class
 } // end namespace itk
 
 #ifndef ITK_MANUAL_INSTANTIATION
-#include "itkTobogganImageFilter.hxx"
+#  include "itkTobogganImageFilter.hxx"
 #endif
 
 #endif
diff --git a/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.hxx b/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.hxx
index 789c319f87..f670afda5b 100644
--- a/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.hxx
+++ b/Modules/Segmentation/Watersheds/include/itkTobogganImageFilter.hxx
@@ -23,75 +23,66 @@
 
 namespace itk
 {
-template< typename TInputImage >
-TobogganImageFilter< TInputImage >
-::TobogganImageFilter()
-{}
 
-template< typename TInputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-TobogganImageFilter< TInputImage >
-::GenerateInputRequestedRegion()
+TobogganImageFilter<TInputImage, TOutputImage>::GenerateInputRequestedRegion()
 {
   Superclass::GenerateInputRequestedRegion();
-  if ( this->GetInput() )
-    {
-    InputImagePointer image =
-      const_cast< typename Superclass::InputImageType * >( this->GetInput() );
+  if (this->GetInput())
+  {
+    InputImagePointer image = const_cast<typename Superclass::InputImageType *>(this->GetInput());
     image->SetRequestedRegionToLargestPossibleRegion();
-    }
+  }
 }
 
-template< typename TInputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-TobogganImageFilter< TInputImage >
-::EnlargeOutputRequestedRegion(DataObject *data)
+TobogganImageFilter<TInputImage, TOutputImage>::EnlargeOutputRequestedRegion(DataObject * data)
 {
   Superclass::EnlargeOutputRequestedRegion(data);
   data->SetRequestedRegionToLargestPossibleRegion();
 }
 
-template< typename TInputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-TobogganImageFilter< TInputImage >
-::PrintSelf(std::ostream & os, Indent indent) const
+TobogganImageFilter<TInputImage, TOutputImage>::PrintSelf(std::ostream & os, Indent indent) const
 {
   Superclass::PrintSelf(os, indent);
 }
 
-template< typename TInputImage >
+template <typename TInputImage, typename TOutputImage>
 void
-TobogganImageFilter< TInputImage >
-::GenerateData()
+TobogganImageFilter<TInputImage, TOutputImage>::GenerateData()
 {
-  InputImageConstPointer inputImage  = static_cast< InputImageConstPointer >( this->GetInput() );
-  OutputImagePointer     outputImage = this->GetOutput();
+  auto               inputImage = static_cast<InputImageConstPointer>(this->GetInput());
+  OutputImagePointer outputImage = this->GetOutput();
 
-  OutputImagePixelType z = NumericTraits< OutputImagePixelType >::ZeroValue();
-  OutputImagePixelType CurrentLabel = NumericTraits< OutputImagePixelType >::ZeroValue();
+  OutputImagePixelType z = NumericTraits<OutputImagePixelType>::ZeroValue();
+  OutputImagePixelType CurrentLabel = NumericTraits<OutputImagePixelType>::ZeroValue();
 
   CurrentLabel += 2;
 
   // Zero the output
-  outputImage->SetBufferedRegion( outputImage->GetRequestedRegion() );
+  outputImage->SetBufferedRegion(outputImage->GetRequestedRegion());
   outputImage->Allocate();
-  outputImage->FillBuffer (z);
+  outputImage->FillBuffer(z);
 
-  typedef ImageRegionConstIterator< InputImageType >  InputIterator;
-  typedef ImageRegionConstIterator< OutputImageType > OutputIterator;
+  using InputIterator = ImageRegionConstIterator<InputImageType>;
+  using OutputIterator = ImageRegionConstIterator<OutputImageType>;
 
-  InputIterator  inIt( inputImage, inputImage->GetRequestedRegion() );
-  OutputIterator outIt( outputImage, outputImage->GetRequestedRegion() );
+  InputIterator  inIt(inputImage, inputImage->GetRequestedRegion());
+  OutputIterator outIt(outputImage, outputImage->GetRequestedRegion());
 
   // Walk through the image
-  while ( !inIt.IsAtEnd() )
-    {
+  while (!inIt.IsAtEnd())
+  {
     // If we find an unlabeled pixel, start labeling
-    if ( outIt.Get() == z )
-      {
+    if (outIt.Get() == z)
+    {
       // Start labeling
-      std::vector< IndexType > Visited;
-      InputImagePixelType      MinimumNeighborValue = inIt.Get();
+      std::vector<IndexType> Visited;
+      InputImagePixelType    MinimumNeighborValue = inIt.Get();
 
       OutputImagePixelType MinimumNeighborClass;
       OutputImagePixelType LabelForRegion = CurrentLabel;
@@ -105,26 +96,25 @@ TobogganImageFilter< TInputImage >
       CurrentPositionIndex = outIt.GetIndex();
       // This is the first pixel we've visited
       Visited.clear();
-      Visited.push_back (CurrentPositionIndex);
-      itkDebugMacro (<< "Found unlabeled pixel at: " << CurrentPositionIndex
-                     << " Value: " << MinimumNeighborValue);
+      Visited.push_back(CurrentPositionIndex);
+      itkDebugMacro(<< "Found unlabeled pixel at: " << CurrentPositionIndex << " Value: " << MinimumNeighborValue);
       // Search along a steepest descent path to a local minimum
       do
-        {
+      {
         // We've touched this pixel
-        outputImage->SetPixel (CurrentPositionIndex, 1);
+        outputImage->SetPixel(CurrentPositionIndex, 1);
         MinimumNeighborIndex = CurrentPositionIndex;
         // DirectionImage->PutPixel ( CurrentPositionIndex, 1 );
         // Check the face connected neighbors
-        for ( Dimension = 0; Dimension < ImageDimension; Dimension++ )
+        for (Dimension = 0; Dimension < ImageDimension; Dimension++)
+        {
+          for (t = 1; t >= -1; t = t - 2)
           {
-          for ( t = 1; t >= -1; t = t - 2 )
-            {
             IndexType NeighborIndex;
             NeighborIndex = CurrentPositionIndex;
             NeighborIndex[Dimension] += t;
-            if ( outputImage->GetRequestedRegion().IsInside (NeighborIndex) )
-              {
+            if (outputImage->GetRequestedRegion().IsInside(NeighborIndex))
+            {
               // This is a valid index to check
               // Possibilities:
               // If NeighborClass == 0  -> Not been checked yet, check it
@@ -133,46 +123,44 @@ TobogganImageFilter< TInputImage >
               // If NeighborClass > 1   -> Found a new neighbor, but only if
               // it's minimum
               OutputImagePixelType NeighborClass;
-              NeighborClass = outputImage->GetPixel (NeighborIndex);
+              NeighborClass = outputImage->GetPixel(NeighborIndex);
               // See if we've already touched it
-              if ( NeighborClass != 1 )
+              if (NeighborClass != 1)
+              {
+                InputImagePixelType NeighborValue = inputImage->GetPixel(NeighborIndex);
+                if (NeighborValue < MinimumNeighborValue)
                 {
-                InputImagePixelType NeighborValue = inputImage->GetPixel (NeighborIndex);
-                if ( NeighborValue < MinimumNeighborValue )
-                  {
-                  MinimumNeighborValue = inputImage->GetPixel (NeighborIndex);
+                  MinimumNeighborValue = inputImage->GetPixel(NeighborIndex);
                   MinimumNeighborIndex = NeighborIndex;
-                  }
                 }
               }
             }
           }
+        }
         FoundMinimum = false;
-        if ( MinimumNeighborIndex != CurrentPositionIndex )
-          {
+        if (MinimumNeighborIndex != CurrentPositionIndex)
+        {
           // Add the neighbor to the Visited list
-          Visited.push_back (MinimumNeighborIndex);
+          Visited.push_back(MinimumNeighborIndex);
           CurrentPositionIndex = MinimumNeighborIndex;
-          }
+        }
         else
-          {
+        {
           FoundMinimum = true;
-          }
+        }
         // Get the true class of this pixel
-        MinimumNeighborClass = outputImage->GetPixel (MinimumNeighborIndex);
-        itkDebugMacro(<< "\tFound Neighbor at: " << MinimumNeighborIndex
-                      << " Value: " << MinimumNeighborValue
+        MinimumNeighborClass = outputImage->GetPixel(MinimumNeighborIndex);
+        itkDebugMacro(<< "\tFound Neighbor at: " << MinimumNeighborIndex << " Value: " << MinimumNeighborValue
                       << " Class: " << MinimumNeighborClass);
         // we've slid into a different class
-        if ( MinimumNeighborClass > 1 )
-          {
+        if (MinimumNeighborClass > 1)
+        {
           FoundMinimum = true;
-          }
         }
-      while ( !FoundMinimum );
+      } while (!FoundMinimum);
 
-      if ( MinimumNeighborClass == 1 )
-        {
+      if (MinimumNeighborClass == 1)
+      {
         // We need to flood fill from the last position we found
         // stored in CurrentPositionIndex.  Connect any pixels
         // having the same value as the minimum we found.
@@ -182,80 +170,78 @@ TobogganImageFilter< TInputImage >
         //   NeighborClass == LabelForRegion -> OK, just ignore
         //   otherwise, we have a problem
 
-        std::vector< IndexType > OpenList;
+        std::vector<IndexType> OpenList;
         OpenList.clear();
-        OpenList.push_back (CurrentPositionIndex);
-        itkDebugMacro (<< "\tFinished slide at: " << CurrentPositionIndex
-                       << " Value: " << MinimumNeighborValue
-                       << " Class: " << MinimumNeighborClass);
-        while ( OpenList.size() )
-          {
+        OpenList.push_back(CurrentPositionIndex);
+        itkDebugMacro(<< "\tFinished slide at: " << CurrentPositionIndex << " Value: " << MinimumNeighborValue
+                      << " Class: " << MinimumNeighborClass);
+        while (!OpenList.empty())
+        {
           // Pop the last one off
           IndexType SeedIndex = OpenList.back();
           OpenList.pop_back();
-          Visited.push_back (SeedIndex);
-          itkDebugMacro (<< "Flood fill, looking at " << SeedIndex);
+          Visited.push_back(SeedIndex);
+          itkDebugMacro(<< "Flood fill, looking at " << SeedIndex);
           // Look at the neighbors
           InputImagePixelType SeedValue;
-          SeedValue = inputImage->GetPixel (SeedIndex);
-          for ( Dimension = 0; Dimension < ImageDimension; Dimension++ )
+          SeedValue = inputImage->GetPixel(SeedIndex);
+          for (Dimension = 0; Dimension < ImageDimension; Dimension++)
+          {
+            for (t = -1; t <= 1; t = t + 2)
             {
-            for ( t = -1; t <= 1; t = t + 2 )
-              {
               IndexType NeighborIndex;
               NeighborIndex = SeedIndex;
               NeighborIndex[Dimension] += t;
-              if ( outputImage->GetRequestedRegion().IsInside (NeighborIndex) )
+              if (outputImage->GetRequestedRegion().IsInside(NeighborIndex))
+              {
+                if (inputImage->GetPixel(NeighborIndex) <= SeedValue)
                 {
-                if ( inputImage->GetPixel (NeighborIndex) <= SeedValue )
-                  {
                   // Found a match, check it's class
-                  OutputImagePixelType NeighborClass = outputImage->GetPixel (NeighborIndex);
+                  OutputImagePixelType NeighborClass = outputImage->GetPixel(NeighborIndex);
                   // We've never seen this pixel before, so add it to the open
                   // list
-                  if ( NeighborClass == z )
-                    {
+                  if (NeighborClass == z)
+                  {
                     // Add it to the open list
-                    OpenList.push_back (NeighborIndex);
-                    outputImage->SetPixel (NeighborIndex, 1);
-                    }
-                  if ( NeighborClass > 1 )
-                    {
+                    OpenList.push_back(NeighborIndex);
+                    outputImage->SetPixel(NeighborIndex, 1);
+                  }
+                  if (NeighborClass > 1)
+                  {
                     MinimumNeighborClass = NeighborClass;
-                    }
                   }
                 }
               }
             }
           }
         }
+      }
 
       // The minimum neighbor class will always be >= 1
-      if ( MinimumNeighborClass == 1 )
-        {
+      if (MinimumNeighborClass == 1)
+      {
         // If we found an unlabeled minimum,
         // Set the LabelForRegion, and increment CurrentLabel
         LabelForRegion = CurrentLabel;
         CurrentLabel++;
-        }
-      if ( MinimumNeighborClass > 1 )
-        {
+      }
+      if (MinimumNeighborClass > 1)
+      {
         // We bumped into another region, equivalent to finding the minimum
         LabelForRegion = MinimumNeighborClass;
         CurrentPositionIndex = MinimumNeighborIndex;
-        }
-      itkDebugMacro (<< "Filling in: " << static_cast< unsigned int >( Visited.size() )
-                     << " with: " << LabelForRegion);
+      }
+      itkDebugMacro(<< "Filling in: " << static_cast<unsigned int>(Visited.size()) << " with: " << LabelForRegion);
       // Loop over all the visited positions, setting their label
-      for ( i = 0; i < Visited.size(); i++ )
-        {
-        outputImage->SetPixel (Visited[i], LabelForRegion);
-        }
+      for (i = 0; i < Visited.size(); i++)
+      {
+        outputImage->SetPixel(Visited[i], LabelForRegion);
       }
+    }
     // On to the next pixel
     ++inIt;
     ++outIt;
-    }
+  }
 }
 } // end namespace itk
 
